// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "FileRead.h", created on 30/06/99.
 * descr : FileReader class
 */
// ----------------------------------------------------------------------------------

#ifndef FileReadH
#define FileReadH

#ifndef _FSTREAM_H
#include <fstream.h>
#endif

// ----------------------------------------------------------------------------------
class Section {
  public:
    int start;
    int lastClassWord;
    XStr name;
};
// ----------------------------------------------------------------------------------
class FileReader {
    ifstream s;
    XStr fileName;
    Stack <Section*> sections;

    void rewindSection();
    bool seekName(XStr name); // searches section for given name
    XStr getWord();
  public:
    // gets value from section, named 'name'. if not given returns def
    XStr getString(XStr name, XStr def);
    int getInt(XStr name, int def);
    float getFloat(XStr name, float def);
    bool getBool(XStr name, bool def);
    void * getBind(XStr name, XStr def, Block<Binder> & dataBase);
    void * findBind(XStr name, Block <Binder> & dataBase);

    bool nextClassWord(); // get next word like 'wall' 'cell' and so on
    XStr classWord;     // store it here

    void goIn(); // go in section '{ }'
    XStr sectionName() { return sections.top()->name; } // named 'sectionName'
    void goOut(); // and when you finish it : go out
    // section utils :
    // goes in (or not) named section
    bool goIn(XStr secName) { if(!seekName(secName)) return false; goIn(); return true; }
    // true if section has no '{ }' - it's only name
    bool emptySection() { return (sections.top()->start == -1); }
    // file handling
    bool open(XStr fname);
    void close();
    XStr getFileName() { return fileName; }
    // error handling. displays also file,line,column and section stack
    void error(XStr xmsg);
    ~FileReader() { close(); }
    bool topLevel() { return sections.top()->start==0; }

    Section * topSect() { return sections.top(); } // for debug only!
};
// ----------------------------------------------------------------------------------

#endif // FileReadH



