// 15.07.99

#ifndef KeyboardH
#define KeyboardH

#ifndef EventsH
#  include "Events.h"
#endif

// ----------------------------------------------------------------------------
class InputDevice : public Object {
  public:
    Object * moveTarget, * commandTarget;
    InputDevice() : moveTarget(0), commandTarget(0) { }
    virtual ~InputDevice() { }
    // 4 ever
    virtual void init(XStr configFile ) = 0;
    virtual void kill() { turnOff(); }
    // 4 a while
    virtual void turnOn()  = 0;
    virtual void turnOff() = 0;
    // called each frame
    virtual void update()  = 0;
    // event waiting stuff -- if not in event wait mode -- handleEvent() 
    // methods of move- and commandTarget are called directly by update
    // this mode is for console
    virtual void eventWaitModeOn() = 0;
    virtual void eventWaitModeOff() = 0;
    virtual void waitForEvent() = 0; // wait 'till death
    virtual Event * getEvent()  = 0; // if no event - returns 0
    virtual XStr className() { return "InputDevice"; }
};
// ----------------------------------------------------------------------------
extern InputDevice * kbd;
// ----------------------------------------------------------------------------

#endif // KeyboardH




