// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "Objects.h", created on 26/06/99.
 * descr : game object for deriving
 *
 */
// ----------------------------------------------------------------------------------
#ifndef ObjectsH
#define ObjectsH

#ifndef GfxH
#  include "Gfx.h"
#endif // GfxH

#ifndef EventsH
#  include "Events.h"
#endif

// ----------------------------------------------------------------------------------
bool canGo(int x, int y, int size);
class GameObject : public Object {
  private:
    SpriteBitmap * cachedBitmap;
    bool angBitmaps;
    float cachedDist;
    float minDist;
    int angleOk,distOk,setColumnFrame;
  protected:
    virtual SpriteBitmap * getBitmapAng(float ang) = 0;
  public:
    float x,y,size,angle;
    int column;
    XStr name;
    SpriteBitmap * getBitmap();
    float getDist();
    GameObject();
    virtual ~GameObject() { }
    virtual bool teleport(float x, float y); // used to place objects on the map too
    virtual bool canMove(float nx, float ny) //  needed by teleport()
      { return canGo((int)nx,(int)ny,(int)size); }
    virtual XStr className() { return "GameObject"; }
    void draw();
    bool setColumn(float dist, int ray);
};
// ----------------------------------------------------------------------------------
class MovingObject : public GameObject {
  public:
    float vx,vy,maxV,maxA,omega,maxOmega,maxAOmega;
    EvMove * me;
    virtual void move(int time);
    virtual void think(int time) = 0;
    virtual void handleEvent(Event * e);
    virtual XStr className() { return "MovingObject"; }
    MovingObject();
};
// ----------------------------------------------------------------------------------

#endif // ObjectsH



