// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "WorldMap.h", created on 16/06/99.
 * descr : contains definitions of classes Cell, Map
 */
// ----------------------------------------------------------------------------------

#ifndef WorldMapH
#define WorldMapH

#ifndef _FSTREAM_H
#  include <fstream.h>
#endif

#ifndef GfxH
#  include "Gfx.h"
#endif

#ifndef BlockH
#  include "Block.h"
#endif

// ----------------------------------------------------------------------------------
class SeedCell;
class GameObject;
class Cell {
  public:
    OkStuff(0xce11ce1);

    Cell(SeedCell*p);
    WallBitmap * wall[4];
    enum { left, up, right, down };
    bool filled,door,known;
    GameObject * obj;
};
// ----------------------------------------------------------------------------------
class MapGenerator;
class Map {
    friend class MapGenerator;
    Cell * cells[64][64]; // -> to dynamic
    int ox,oy; // for drawMap() method, old player x,y to delete.

    void makeCell();
    void makeWall();
    void readMap();

    void deleteCells();

    MapGenerator * gen;
    Block <Binder> walls;
  public:
    // now both max 64
    int w,h;
    int startX, // ;)
        startY; // startup position
    // brightness of floor and ceil
    float lightFloor, lightCeil;
    // there's only one bmp for ceil and one for floor.
    // 'picture' is map displayed in left bottom corner
    Bitmap ceilBmp, floorBmp, picture;
    XStr name;
    Cell * cell(int x, int y);
    void read(XStr fname); // reads info how to generate map
    void drawMap(); // draws 'picture'
    void generate(); // surprise! genrates map (on the base of read info)
    Map();
    ~Map();
};
extern Map map;
// ----------------------------------------------------------------------------------

#endif // WorldMapH




