// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "Except.h", created on 29/06/99.
 * descr : exception handling
 *
 */
// ----------------------------------------------------------------------------------

#ifndef ExceptH
#define ExceptH

// ----------------------------------------------------------------------------------
class EBase {
  public:
    XStr xmsg;
    virtual XStr id() { return "EBase"; }
    EBase(XStr x) : xmsg(x) { }
    XStr format();
    virtual ~EBase() { }
};
// ----------------------------------------------------------------------------------
#define EClass(name,ancestor) \
class name : public ancestor { \
  public: \
    virtual XStr id() { return ancestor::id() + ":" #name; } \
    name(XStr x) : ancestor(x) { } \
}
// ----------------------------------------------------------------------------------
// EDead finish the program immiditiely
EClass(EDead,EBase);
EClass(EAssert,EDead);
EClass(EScreen,EDead);
// ERecoverable in main game loop can be ignored
EClass(ERecoverable,EBase);
// Data Types
EClass(ETemplate,ERecoverable);
EClass(EBlock,ETemplate);
EClass(EStack,EBlock); // deriving from block because Stack is based on it
EClass(EFIFO,EBlock);  // didto
// other
EClass(EParseError,ERecoverable);
EClass(EFile,ERecoverable);
// ----------------------------------------------------------------------------------
// macros for easy finishing the program ..
#define halt()         deadFood("halt()",__FILE__,__LINE__,__PRETTY_FUNCTION__)
#define haltx(args...) deadFood(xprintf(args),__FILE__,__LINE__,__PRETTY_FUNCTION__)
#define assert(test) ((test)?(void)0:(void)deadAssert(#test,__FILE__,__LINE__,__PRETTY_FUNCTION__))
#define haltErrno(args...) deadFoodErrno(xprintf(args),__FILE__,__LINE__,__PRETTY_FUNCTION__)
// ----------------------------------------------------------------------------------
EDead deadFood(XStr msg, char * file, int line, char * func);
EDead deadFoodErrno(XStr msg, char * file, int line, char * func);
void deadAssert(char * test, char * file, int line, char * func);
// writes message to stderr and 'dbg' file, raises SIGABRT (dumps trace back), and finishes
void handleException(EBase & e);
// ----------------------------------------------------------------------------------

#endif // ExceptH




